'use strict';

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _require = require('lodash'),
    isObject = _require.isObject;

var _require2 = require('./constants'),
    TSIL_VALUE = _require2.TSIL_VALUE;

module.exports = {};

module.exports.modify = function (flat, callback) {
  return flat.map(function (node) {
    return Object.assign({}, node, _defineProperty({}, TSIL_VALUE, callback(node[TSIL_VALUE])));
  });
};

module.exports.merge = function (flat, callback) {
  return flat.map(function (node) {
    var value = node[TSIL_VALUE];
    var change = callback(value);

    return Object.assign({}, node, _defineProperty({}, TSIL_VALUE, isObject(value) && isObject(change) ? Object.assign({}, value, change) : change));
  });
};